package com.blazinggames.cq1;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.net.*;
import java.util.Hashtable;

import com.blazinggames.urcl.data.LoadingBar;

/**
 * Coffee Quest Open Source Release
 * Copyright (C) 1997-1998, 2002,2004 Blazing Games Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * 
 * The Coffee Quest 1 applet.
 *
 * @author Billy D. Spelchan
 * @version 2.10.040103
 */
public class CQ1
extends Applet
implements MouseListener, KeyListener
{
// *********************
// ***** CONSTANTS *****
// *********************
    
    // Parameters
	private static String BASE64ENC = "-+abcdefghijklmnopqrstuHIJKLMNOPQRSTUvwxyz13VWXYZ57ABCDEFG8624@*";

    private static final String VIEW = "VIEW";
    private static final String AUTOMAP = "AUTOMAP";
    private static final String COMPASS = "COMPASS";
    private static final String MESSAGE = "MESSAGE";
    private static final String INVENTORY = "INVENTORY";
    private static final String ICON_SIZE = "ICON_SIZE";
    private static final String IMAGE = "IMAGE";
    private static final String MAP = "MAP";
    
    // image index list
    private static final int IMG_TITLE = 0;
    private static final int IMG_MAKER = 1;
    private static final int IMG_FOUNTAIN = 2;
    private static final int IMG_GRINDER = 3;
    private static final int IMG_POWER = 4;
    private static final int IMG_BEANS = 5;
    private static final int IMG_CUP = 6;
    private static final int IMG_POT = 7;
    private static final int IMG_FILTER = 8;
    private static final int IMG_SUGAR = 9;
    private static final int IMG_GREENKEY = 10;
    private static final int IMG_BLUEKEY = 11;
    private static final int IMG_DOOR = 12;
    private static final int IMG_GREENDOOR = 13;
    private static final int IMG_BLUEDOOR = 14;
    private static final int IMG_ODDWALL = 15;
    private static final int IMG_EVENWALL = 16;
    private static final int IMG_ODDBACKDROP = 17;
    private static final int IMG_EVENBACKDROP = 18;
    private static final int IMG_COMPASS = 19;
    private static final int IMG_ICONS = 20;
    private static final int IMG_TOTAL = 21;
    private static final int IMG_TOTAL_CELLS = 17;
    
	// Ordering of drawing cells
	static final int MZ_FMCount[] = {-2, -1, 2, 1, 0};
	static final int MZ_SCount[] = {-1, 1, 0};
	// Colors for automap
	static final short nMapColors[][] =  {
		{255,255,255}, {255,255,255}, {255,255,255}, {255,255,255},
		{255,255,255}, {255,255,255}, {255,255,255}, {255,255,255},
		{255,255,255}, {255,255,255}, {255,255,255}, {255,255,255},
		{255,0,0}, {0,255,0}, {0,0,255}, {0,0,0}
	};
	static Color clrMap[] = new Color[16];
	// 3d Cells for drawing tiles
	static final int nCellTypes[] = {
		0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2};
	// other constants
	static final int ICONBAR_Y = 240;

// *********************
// ***** VARIABLES *****
// *********************
    
	// Game variables
	byte map[][] = new byte[128][128];
	int nPctLoaded;
	String sMessage;
	Image iBackdrop1, iBackdrop2;
	Image iCompass[] = new Image[4];
	Image iIcons[][] = new Image[2][10];
	Image iTemp;

  Image iTitle;

	// Double buffering for 3d Display
	Image i3DDisplay;
	Graphics g3DDisplay;
	// Double buffering for automap
	Image iAutomap;
	Graphics gAutomap;

	ImgCell icTile[] = new ImgCell[17];
	int trackCount;
	boolean bRefreshDisplay;

	Font fMessage = new Font("TimesRoman", Font.PLAIN, 14);
	MediaTracker  tracker;
	Thread loader;

	// Player variables
	int nPlayerX, nPlayerY, nPlayerD;
	boolean bMaker, bWater, bGrinder, bBeans, bCup, bPot, bFilter, bSugar;
	int nGreenKeys, nBlueKeys;
	boolean bWonGame;

    private String errorMessage;
    private boolean errorOccured = false;
    private Hashtable _config = new Hashtable();

// NEW 2.0 variables
    private Rectangle _viewRect;
    private Rectangle _automapRect;
    private Rectangle _compassRect;
    private Rectangle _messageRect;
    private Rectangle _inventoryRect;
    private Rectangle _iconSize;
	private int _mapSize;
	
    private MemoryImageSource _misMaze;
    private int _rawMaze[];
    private Image _imgMaze;
    
    private LoadingBar _loadbar;
    
// *********************************
// ***** METHODS - From Applet *****
// *********************************
    
    /**
	 * Initialize the applet 
	 */
	public void init()
    {
    	_loadbar = new LoadingBar(this, "Coffee Quest 1osr");
        addMouseListener(this);
        addKeyListener(this);
        requestFocus();
        
        tracker  =  new  MediaTracker(this);
		trackCount = 0;

		iAutomap = createImage(132, 132);
		gAutomap = iAutomap.getGraphics();
		gAutomap.setColor(Color.lightGray);
		gAutomap.fillRect(0,0, 132,132);

		for (int cntr = 0; cntr < 16; ++cntr)
			clrMap[cntr] = new Color(nMapColors[cntr][0],
						nMapColors[cntr][1], nMapColors[cntr][2]);
		this.setBackground(Color.white);
		nPlayerX = nPlayerY = 1;
		loader = new LoadStuff(this);
		loader.start();
    }

	/**
	 * Applet Start method
	 */
	public void start() 
	{
		requestFocus();
	}

	/**
	 * Applet destroy method
	 */
	public void destroy()
    {
        try
        {
            if (loader != null) {
                loader.stop();
                loader = null;
            }
        }
        catch (Exception e) {;}
        super.destroy();
	}

	/**
	 * 
	 * @see java.applet.Applet#getAppletInfo()
	 */
  	public String getAppletInfo() 
  	{
    	return "Coffee Quest 2.10.040103 Copyright 1997-1998, 2002,2004 Blazing Games Inc.";
	}

	/**
	 * Grab an image using the media tracker to fully load the image
	 * @param img image to be fully loaded
	 * @param nPct percentage to update loading bar
	 */
	protected boolean myGetImage(Image img, int nPct) 
	{
		tracker.addImage(img,  trackCount);
		try  {
			tracker.waitForID(trackCount);
		}  catch  (InterruptedException  e)  {
			System.out.println("Image loading Interrupted Exception");
		}
		if (tracker.isErrorID(trackCount))
		{
			System.err.println("Image loading Error");
			return false;
		}
		++trackCount;
		nPctLoaded = nPct;
		bRefreshDisplay = true;
		repaint();
		return true;
	}

	/**
	 * Break compass into separate images
	 *  
	 * @param img image of the compas to be divided
	 */
	protected void divideCompass(Image img) {
		ImageFilter cif;
		ImageProducer producer;
		MediaTracker track  =  new  MediaTracker(this);

		int cntr;
        int tempw = Math.min(_compassRect.width, img.getWidth(this)-1);
        int temph = Math.min(_compassRect.height, img.getHeight(this)/5);
//System.out.println("Compass: " + tempw + "," + temph);
        for (cntr = 0; cntr < 4; ++cntr)
        {
			cif = new CropImageFilter(0,temph * cntr, tempw,temph);
			producer = new FilteredImageSource(img.getSource(),cif);
			iCompass[cntr] = createImage(producer);
			track.addImage(iCompass[cntr], cntr);
		}
		try
        {
			track.waitForAll();
		}  catch  (InterruptedException  e)  {}
	}

	/**
	 * Break a strip of icon images into individual icons
	 * 
	 * @param img icon image strip
	 */
	protected void divideIcons(Image img) 
	{
		ImageFilter cif;
		ImageProducer producer;
		MediaTracker track  =  new  MediaTracker(this);

		int cntr;

		for (cntr = 0; cntr < 10; ++cntr) {
			cif = new CropImageFilter(_iconSize.width * cntr,0, _iconSize.width,_iconSize.height);
			producer = new FilteredImageSource(img.getSource(),cif);
			iIcons[0][cntr] = createImage(producer);
			track.addImage(iIcons[0][cntr], 0);

			cif = new CropImageFilter(_iconSize.width * cntr,_iconSize.height, _iconSize.width,_iconSize.height);
			producer = new FilteredImageSource(img.getSource(),cif);
			iIcons[1][cntr] = createImage(producer);
			track.addImage(iIcons[1][cntr], 0);
		}
		try  {
			track.waitForID(0);
		}  catch  (InterruptedException  e)  {}
	}

	/**
	 * loading method
	 */
	protected void loadStuff()
    {
		byte buffer[] = new byte[4];
		byte mbuf[] = new byte[128];
		int cntr, cntr2;

        loadConfig();
		repaint();
        if (errorOccured)
            return;

        String s = (String)_config.get(IMAGE+"[0]");
        if (s != null)
            iTitle =  getImage(getCodeBase(), s);
        nPctLoaded = 10;
        bRefreshDisplay = true;
        repaint();

        s = (String)_config.get(IMAGE+"["+IMG_ODDBACKDROP+"]");        
		iBackdrop1 = getImage(getCodeBase(), s);
		myGetImage(iBackdrop1, 14);
        s = (String)_config.get(IMAGE+"["+IMG_EVENBACKDROP+"]");        
		iBackdrop2 = getImage(getDocumentBase(), s);
		myGetImage(iBackdrop2, 18);
        s = (String)_config.get(IMAGE+"["+IMG_COMPASS+"]");        
		iTemp = getImage(getCodeBase(), s);
		myGetImage(iTemp, 22);
		divideCompass(iTemp);

        s = (String)_config.get(IMAGE+"["+IMG_ICONS+"]");
		iTemp = getImage(getCodeBase(), s);
		myGetImage(iTemp, 26);
		divideIcons(iTemp);

		icTile[0] = new ImgCell(iTemp, 0, this);
		for (cntr = 1; cntr < IMG_TOTAL_CELLS; ++cntr)
        {
            s = (String)_config.get(IMAGE+"["+cntr+"]");
			iTemp = getImage(getCodeBase(), s);
            System.out.println("loading " + s);
			if (myGetImage(iTemp, 26 + 4 * cntr) == false)
				System.err.println("Failed to load " + s);
			icTile[cntr] = new ImgCell(iTemp, nCellTypes[cntr], this);
		}

		try {
            s = (String)_config.get(MAP);
            if (s == null)
                s = "res/cq1/maze.txt";
			URL host = new URL(getCodeBase(), s);

			BufferedReader iFile = new BufferedReader(new InputStreamReader(host.openStream()));

			String temp = iFile.readLine(); // skip header
			int tindex;
			if (temp.indexOf("CQ1") >= 0)
			{
				// read map size then set and clear (in case file problem) map 
				_mapSize = Integer.parseInt(iFile.readLine());
				for (int cntrY = 0; cntrY < _mapSize; ++cntrY)
				{
					temp = iFile.readLine();
					for (int cntrX = 0; cntrX < _mapSize; ++cntrX)
					{
						tindex = temp.charAt(cntrX);
						map[cntrY][cntrX] = (byte)BASE64ENC.indexOf(tindex);
					}
				}
			}
			else
			{
				errorMessage = "Invalid map file";
				errorOccured = true;
				repaint();
				return;
			}
			// Close file
			iFile.close();
		}
		catch (MalformedURLException me) {
			System.out.println("URL Error");
			errorMessage = "Invalid URL Specified";
			errorOccured = true;
			repaint();
			return;
		}
		catch (IOException e) {
			errorMessage = "Problem reading map";
			errorOccured = true;
			System.out.println("IO Error");
			repaint();
			return;
		}
		nPctLoaded = 99;
		repaint();
		try { Thread.sleep(1000);} catch (Exception ex){};
		nPctLoaded = 100;
		bRefreshDisplay = true;
        render3DMaze();
		repaint();
	}

    /**
     * move player forward (forward being direction they are facing)
     */
	public void moveForward() {
		int tempX, tempY;

		tempX = nPlayerX;
		tempY = nPlayerY;
		switch (nPlayerD) {
			case 0:	tempY = (nPlayerY - 1) & 127;
					break;
			case 1: tempX = (nPlayerX + 1) & 127;
					break;
			case 2:	tempY = (nPlayerY + 1) & 127;
					break;
			case 3:	tempX = (nPlayerX - 1) & 127;
					break;
		}

		if ( activateTile(tempX, tempY) ) {
			nPlayerX = tempX;
			nPlayerY = tempY;
			UpdateAutomap();
		}
	}

	/**
	 * perform any action necessary when player enters tile.
	 * 
	 * @param nX X location of tile
	 * @param nY Y location of tile
	 * @return true if can enter the tile
	 */
	public boolean activateTile(int nX, int nY) {
		int nTile;
		boolean bCanEnter = true;

		sMessage = null;
		nTile = map[nY][nX];
		switch (nTile) {
			case 1:		// Coffee maker
				bMaker = true;
				map[nY][nX] = 0;
				sMessage = "You picked up the Coffee Maker!";
				break;
			case 2:		// Water Fountain
				if (bWater)
					sMessage = "You already have water!";
				else if (bPot) {
					bWater = true;
					sMessage = "You Fill the coffee pot with water!";
				} else {
					sMessage = "You need something to hold the water.";
				}
				bCanEnter = false;
				break;
			case 3:		// Coffee Grinder
				bGrinder = true;
				map[nY][nX] = 0;
				sMessage = "You picked up the Coffee Grinder!";
				break;
			case 4:		// Power Outlet
				if (bMaker && bWater && bGrinder && bBeans && bCup
							&& bPot && bFilter) {
					bWonGame = true;
					bRefreshDisplay = true;
				} else
					sMessage = "You are missing some components!";
				bCanEnter = false;
				break;
			case 5:		// Coffee Beans
				bBeans = true;
				map[nY][nX] = 0;
				sMessage = "You picked up the Coffee Beans!";
				break;
			case 6:		// Coffee Cup
				bCup = true;
				map[nY][nX] = 0;
				sMessage = "You picked up the Coffee Cup!";
				break;
			case 7:		// Coffee Pot
				bPot = true;
				map[nY][nX] = 0;
				sMessage = "You picked up the Coffee Pot!";
				break;
			case 8:		// Coffee Filters
				bFilter = true;
				map[nY][nX] = 0;
				sMessage = "You picked up the Coffee Filters!";
				break;
			case 9:		// Cream + Sugar
				bSugar = true;
				map[nY][nX] = 0;
				sMessage = "You picked up the Cream and Sugar!";
				break;
			case 10:	// Green Key
				++nGreenKeys;
				map[nY][nX] = 0;
				sMessage = "You picked up a green key!";
				break;
			case 11:	// Blue Key
				++nBlueKeys;
				map[nY][nX] = 0;
				sMessage = "You picked up a blue key!";
				break;
			case 13:	// Green Door
				if (nGreenKeys > 0) {
					--nGreenKeys;
					map[nY][nX] = 12;
					sMessage = "You unlock the door!";
				} else
					sMessage = "You don\'t have a key!";
				bCanEnter = false;
				break;
			case 14:	// Blue door
				if (nBlueKeys > 0) {
					--nBlueKeys;
					map[nY][nX] = 12;
					sMessage = "You unlock the door!";
				} else
					sMessage = "You don\'t have a key!";
				bCanEnter = false;
				break;
			case 15:	// walls
			case 16:
				bCanEnter = false;
				sMessage = "You can\'t walk through walls!";
				break;
			default:
				/* Do nothing */
		}
		return bCanEnter;
	}

	/**
	 * update the display. Overriden so update doesn't flicker.
	 */
	public void update(Graphics g) {
		if ( (nPctLoaded < 100) && (!errorOccured) )
			;
		else if (bRefreshDisplay)
        {
			g.setColor(getBackground());
			g.fillRect(0,0, 640, 480);
			g.setColor(getForeground());
			bRefreshDisplay = false;
		}
		paint(g);
	}

	/**
	 * Paint the image
	 */
	public void paint(Graphics g) {
        if (errorOccured)
        {
			g.setColor(getBackground());
			g.fillRect(0,0, 640, 480);
			g.setColor(getForeground());
			Font f = new Font("TimesRoman", Font.BOLD, 42);
            g.setFont(f);
            g.setColor(Color.blue);
            g.drawString("ERROR OCCURED", 75, 75);
            g.drawString(errorMessage, 75, 150);
            return;
        }

		if (nPctLoaded < 100) {
			if (_loadbar != null )
			{
				_loadbar.setLoadPercent(nPctLoaded);
				_loadbar.render(g, this);
			}
		}
		else if (bWonGame)
        {
			Font f = new Font("TimesRoman", Font.BOLD, 64);
			g.setFont(f);
			g.setColor(Color.blue);
			g.drawString("YOU WIN!", 75, 150);
			if (bSugar)
            {
				Font f2 = new Font("TimesRoman", Font.BOLD, 24);
				g.setFont(f2);
				g.setColor(Color.blue);
				g.drawString("You even found the Cream and Sugar!", 10, 250);
			}
		}
		else
        {
            g.drawImage(_imgMaze, _viewRect.x, _viewRect.y, this);
			g.drawImage(iAutomap, _automapRect.x,_automapRect.y, this);
			g.setColor(Color.red);
            int amw = 128/Math.max(1, _mapSize);
            int amh = 128/Math.max(1, _mapSize);
			g.fillRect( _automapRect.x+nPlayerX*amw-2, _automapRect.y+nPlayerY*amh-2, amw+4,amh+4);
			g.setColor(getBackground());
			g.fillRect(_messageRect.x,_messageRect.y, _messageRect.width,_messageRect.height);
			if (sMessage != null)
            {
				g.setFont(fMessage);
				g.setColor(Color.black);
				g.drawString(sMessage, _messageRect.x, _messageRect.y - 5 + _messageRect.height);
			}
			paintIconBar(g);
//            System.out.println("Dir="+nPlayerD);
			g.drawImage(iCompass[nPlayerD], _compassRect.x,_compassRect.y, this);

		}
	}

	/**
	 * Draw the icon bar
	 * 
	 * @param g graphics context
	 */
	protected void paintIconBar(Graphics g)
    {
        int x = _inventoryRect.x;
        int y = _inventoryRect.y;
        // :CHEAT: we use iconSize .x to hold hgap and .y to hold keygap
        int step = _iconSize.width + _iconSize.x;
        int keygap = _iconSize.y;
        
		if (bMaker)
			g.drawImage(iIcons[1][0], x,y, this);
		else
			g.drawImage(iIcons[0][0], x,y, this);

        x += step;
		if (bGrinder)
			g.drawImage(iIcons[1][1], x,y, this);
		else
			g.drawImage(iIcons[0][1], x,y, this);

        x += step;
		if (bBeans)
			g.drawImage(iIcons[1][2], x,y, this);
		else
			g.drawImage(iIcons[0][2], x,y, this);

        x += step;
		if (bCup)
			g.drawImage(iIcons[1][3], x,y, this);
		else
			g.drawImage(iIcons[0][3], x,y, this);

        x += step;
		if (bPot) {
			if (bWater)
				g.drawImage(iIcons[1][9], x,y, this);
			else
				g.drawImage(iIcons[1][4], x,y, this);
		} else
			g.drawImage(iIcons[0][4], x,y, this);

        x += step;
		if (bFilter)
			g.drawImage(iIcons[1][5], x,y, this);
		else
			g.drawImage(iIcons[0][5], x,y, this);

        x += step;
		if (bSugar)
			g.drawImage(iIcons[1][6], x,y, this);
		else
			g.drawImage(iIcons[0][6], x,y, this);

		Font f = new Font("TimesRoman", Font.PLAIN, 12);
		g.setFont(f);

        x += step;
        if (nGreenKeys > 0) {
			g.drawImage(iIcons[1][7], x,y, this);
			String s1 = String.valueOf(nGreenKeys);
			g.setColor(Color.green);
			g.drawString(s1, x + keygap,y+_iconSize.height);
		} else
			g.drawImage(iIcons[0][7], x,y, this);

        x += step;
		if (nBlueKeys > 0) {
			g.drawImage(iIcons[1][8], x,y, this);
			String s1 = String.valueOf(nBlueKeys);
			g.setColor(Color.blue);
			g.drawString(s1, x + keygap, y+_iconSize.height);
		} else
			g.drawImage(iIcons[0][8], x,y, this);

	}

	/**
	 * Get the tile (cell) at the indicated offset
	 * 
	 * @param nOffAhead how far ahead of the player
	 * @param nOffSide how far to the side (negative being left, positive right)
	 * @return tile at indicated location
	 */
	byte getOffsetCell(int nOffAhead, int nOffSide)
	{
		int nTempX, nTempY;
		byte nRetTemp;

		nTempX = nPlayerX;
		nTempY = nPlayerY;
		switch (nPlayerD) {
			case 0:	nTempX = (nTempX + nOffSide) & 127;
					nTempY = (nTempY - nOffAhead) & 127;
					break;
			case 1:	nTempX = (nTempX + nOffAhead) & 127;
					nTempY = (nTempY + nOffSide) & 127;
					break;
			case 2:	nTempX = (nTempX - nOffSide) & 127;
					nTempY = (nTempY + nOffAhead) & 127;
					break;
			case 3:	nTempX = (nTempX - nOffAhead) & 127;
					nTempY = (nTempY - nOffSide) & 127;
					break;
		}
		nRetTemp = map[nTempY][nTempX];
		if ( (nRetTemp < 0) || (nRetTemp > 15) )
			nRetTemp = 0;
		if (nRetTemp == 15)
			nRetTemp = (byte)(nRetTemp + ( (nTempX+nTempY) & 1));

		return nRetTemp;
	}

	/**
	 * Update the automap image
	 */
	protected void UpdateAutomap()
    {
        int pw = 128 / Math.max(1, _mapSize);
        int ph = 128 / Math.max(1, _mapSize);
        
		gAutomap.setColor(clrMap[map[nPlayerY][nPlayerX]]);
		gAutomap.fillRect(nPlayerX*pw, nPlayerY*ph, pw,ph);
		gAutomap.setColor(clrMap[map[(nPlayerY+1)&127][nPlayerX]]);
		gAutomap.fillRect(nPlayerX*pw, ((nPlayerY+1)&127)*ph, pw,ph);
		gAutomap.setColor(clrMap[map[(nPlayerY-1)&127][nPlayerX]]);
		gAutomap.fillRect(nPlayerX*pw,((nPlayerY-1)&127)*ph, pw,ph);
		gAutomap.setColor(clrMap[map[nPlayerY][(nPlayerX+1)&127]]);
		gAutomap.fillRect( ((nPlayerX+1)&127)*pw,nPlayerY*ph, pw,ph);
		gAutomap.setColor(clrMap[map[nPlayerY][(nPlayerX-1)&127]]);
		gAutomap.fillRect( ((nPlayerX-1)&127)*pw, nPlayerY*ph, pw,ph);
	}


// *************************************************
// ***** METHODS - Configuration File Handling *****
// *************************************************
    
    /**
     * Load the configuration file. This file is stored in the CONFIG applet
     * parameter.
     */
    private void loadConfig()
    {
        String s = getParameter("CONFIG");
        if (s == null)
        {
            errorMessage = "Missing properties";
            errorOccured = true;
            return;
        }
        URL url;
        try
        {
            url = new URL(getCodeBase(), s);
        }
        catch (MalformedURLException mue)
        {
            errorMessage = "Invalid URL specified for config";
            errorOccured = true;
            return;
        }
        
        String temp;
        String command, param;
        int cntr, index;
        BufferedReader in;

        try
        {
            in = new BufferedReader(new InputStreamReader(url.openStream()));
            temp = in.readLine();
            do
            {
//System.out.println(temp);
                index = temp.indexOf(' ');
                if (index > 2) // must have 3 characters before space
                {
                    command = temp.substring(0, index);
                    param = temp.substring(index+1);
//System.out.println("CMD=" + command + " param=" + param);
                    _config.put(command, param);
                }
                temp = in.readLine();
            }
            while (temp != null);
            in.close();
        }
        catch (IOException ioe)
        {
            errorMessage = "IO Exception reading config";
            errorOccured = true;
            return;
        }
        configViews();
    }

	/**
	 * load the configuration information that is related to the layout of the display
	 */
    private void configViews()
    {
        _viewRect = parseRect((String)_config.get(VIEW));
        _automapRect = parseRect((String)_config.get(AUTOMAP));
        _compassRect = parseRect((String)_config.get(COMPASS));
        _messageRect = parseRect((String)_config.get(MESSAGE));
        _inventoryRect = parseRect((String)_config.get(INVENTORY));
        _iconSize = parseRect((String)_config.get(ICON_SIZE));

        i3DDisplay = createImage(_viewRect.width, _viewRect.height);
        g3DDisplay = i3DDisplay.getGraphics();
        iAutomap = createImage(132, 132);
        gAutomap = iAutomap.getGraphics();
        gAutomap.setColor(Color.lightGray);
        gAutomap.fillRect(0,0, 132,132);

        _rawMaze = new int[_viewRect.width * _viewRect.height];
        _misMaze = new MemoryImageSource(_viewRect.width, _viewRect.height,_rawMaze, 0, _viewRect.width);
        _misMaze.setAnimated(true);
        _imgMaze = createImage(_misMaze);
    }
    
    /**
     * Take a string and break it into an array of strings broken appart by the
     * indicated character.
     * 
     * @param s string to be broken appart
     * @param ch character to use as separator
     * @return array of strings
     */
    public String[] parseString(String s, char ch)
    {
        int cntr, count = 0;
        int len = s.length();
        char sc;

        for (cntr = 0; cntr < len; ++cntr)
        {
            sc = s.charAt(cntr);
            if (sc == ch)
                ++count;
        }

        String rs[] = new String[count+1];
        int start = 0;
        int last = 0;
        for (cntr = 0; cntr < count; ++cntr)
        {
            last = s.indexOf(ch, start);
            rs[cntr] = s.substring(start, last);
            start = last + 1;
        }
        rs[count] = s.substring(start);

        return rs;
    }

	/**
	 * Converts string into integer. If the string does not form a valid number
	 * returns the provided default value.
	 * 
	 * @param s String to be converted into a number
	 * @param d default value
	 * @return integer value of string, or default if string invalid
	 */
    public int parseInt(String s, int d)
    {
        int r;

        try
        {
            r = Integer.parseInt(s);
        }
        catch (Exception e)
        {
            r = d;
        }

        return r;
    }

	/**
	 * takes a string and breaks it down into a rectangle.
	 * 
	 * @param s A string in the format x,y,w,h
	 * @return rectangle that is defined in the string
	 */
    public Rectangle parseRect(String s)
    {
        String args[] = parseString(s, ',');
        if ( (args == null) || (args.length != 4) )
        {
            return new Rectangle(0,0,0,0);
        }
        int x = parseInt(args[0], 0);
        int y = parseInt(args[1], 0);
        int w = parseInt(args[2], 0);
        int h = parseInt(args[3], 0);
        return new Rectangle(x, y, w, h);
    }

	/**
	 * Renders the display
	 */
    private void render3DMaze()
    {
        int cntr, nTempOff, nTempCell;

        int backtype = (nPlayerX + nPlayerY) & 1;

        // Draw backdrop
        if (backtype == 1)
            icTile[1].setBackdrop(_rawMaze, _viewRect.width, _viewRect.height, iBackdrop1);
        else
            icTile[1].setBackdrop(_rawMaze, _viewRect.width, _viewRect.height, iBackdrop2);

        // draw far wall
        for (cntr = 0; cntr < 5; cntr++)
        {
            nTempOff = MZ_FMCount[cntr];
            nTempCell = getOffsetCell(3, nTempOff);
            icTile[nTempCell].renderOverlayRaw(_rawMaze, _viewRect.width, _viewRect.height, 2+nTempOff);
        }

        // draw Medium wall
        for (cntr = 0; cntr < 5; cntr++) {
            nTempOff = MZ_FMCount[cntr];
            nTempCell = getOffsetCell(2, nTempOff);
            icTile[nTempCell].renderOverlayRaw(_rawMaze, _viewRect.width, _viewRect.height, 7+nTempOff);
        }

        // draw Short wall
        for (cntr = 0; cntr < 3; cntr++) {
            nTempOff = MZ_SCount[cntr];
            nTempCell = getOffsetCell(1, nTempOff);
            icTile[nTempCell].renderOverlayRaw(_rawMaze, _viewRect.width, _viewRect.height, 11+nTempOff);
        }

        // draw point blank walls
        nTempCell = getOffsetCell(0, -1);
        icTile[nTempCell].renderOverlayRaw(_rawMaze, _viewRect.width, _viewRect.height, 13);
        nTempCell = getOffsetCell(0, 1);
        icTile[nTempCell].renderOverlayRaw(_rawMaze, _viewRect.width, _viewRect.height, 14);

        _misMaze.newPixels();
    }


// ****************************************
// ***** METHODS - From MouseListener *****
// ****************************************
    
    /** Interface obligation - ignored */
    public void mouseClicked(MouseEvent e)
    {
    }
    
	/** Interface obligation - ignored */
    public void mousePressed(MouseEvent e)
    {
    }
    
    /**
     * interface called when mouse button has been released
     */
    public void mouseReleased(MouseEvent e)
    {
        int x = e.getX();
        int y = e.getY();
        
        if (nPctLoaded >= 100) {
            if (_compassRect.contains(x,y)) {
                int segment = (x - _compassRect.x) / (_compassRect.width / 3);
                if (segment == 0) {			// turn left
                    nPlayerD = (byte)( (nPlayerD - 1) & 3 );
                } else if (segment == 1) {	// move foreward
                    moveForward();
                } else {				// turn right
                    nPlayerD = (byte)( (nPlayerD + 1) & 3 );
                }
                render3DMaze();
                repaint();
            }
        }
    }
    
    /** Interface obligation - ignored */
    public void mouseEntered(MouseEvent e)
    {
    }
    
    /** Interface obligation - ignored */
    public void mouseExited(MouseEvent e)
    {
    }


// **************************************
// ***** METHODS - From KeyListener *****
// **************************************

    /** Interface obligation - ignored */
    public void keyTyped(KeyEvent e)
    {
    }

    /** Interface obligation - ignored */
    public void keyPressed(KeyEvent e)
    {
    }

	/**
	 * Called when key released.
	 */
    public void keyReleased(KeyEvent e)
    {
        int key = e.getKeyCode();
        
        if (nPctLoaded >= 100)
        {
            switch (key)
            {
                case KeyEvent.VK_I: // I key
                case KeyEvent.VK_UP:
                    moveForward();
                    render3DMaze();
                    repaint();
                    break;
                    
                case KeyEvent.VK_K: // K key
                case KeyEvent.VK_RIGHT:
                    nPlayerD = (byte)( (nPlayerD + 1) & 3 );
                    render3DMaze();
                    repaint();
                    break;
                    
                case KeyEvent.VK_J: // J key
                case KeyEvent.VK_LEFT:
                    nPlayerD = (byte)( (nPlayerD - 1) & 3 );
                    render3DMaze();
                    repaint();
                    break;
                    
                default:
                    // nothing
            }
        }        
    }
}
